leetcode724 寻找数组的中心下标

题目

给你一个整数数组 nums ,请计算数组的 中心下标。

数组中心下标 是数组的一个下标,其左侧所有元素相加的和等于右侧所有元素相加的和。

如果中心下标位于数组最左端,那么左侧数之和视为 0 ,因为在下标的左侧不存在元素。这一点对于中心下标位于数组最右端同样适用。

如果数组有多个中心下标,应该返回 最靠近左边 的那一个。如果数组不存在中心下标,返回 -1 。

复制代码
输入:nums = [1, 7, 3, 6, 5, 6]
输出:3
解释:
中心下标是 3 。
左侧数之和 sum = nums[0] + nums[1] + nums[2] = 1 + 7 + 3 = 11 ,
右侧数之和 sum = nums[4] + nums[5] = 5 + 6 = 11 ,二者相等。

解法

前缀和的经典题目,前缀和的思路是由于解题过程中要频繁用到数组的和,那么我们不妨一开始就直接构建出数组保存数组的前缀和。

具体思路如下:

至于为什么要从s0开始构造,敲黑板,是因为前缀和一般利用起来都是大的前缀和减去小的前缀和的形式,如果不构造s0,则无法以同一种形式处理所有带a0的部分,两个前缀和相减,都会直接消去它。

另外需要注意的是前i-1项和的索引是si。

我的解法如下:(找到我学不了算法的原因了,我学到了前缀和的形式,别人学到了前缀和的灵魂)

复制代码
class Solution:
    def pivotIndex(self, nums: List[int]) -> int:
        s = [0]*(len(nums)+1)
        for i, x in enumerate(nums):
            s[i+1] = s[i] + x

        for i in range(1,len(nums)+1):
            if i==1:
                if s[len(nums)]-s[1]==0:
                    return i-1
            elif i==len(nums):
                if s[len(nums)]-nums[len(nums)-1]==0:
                    return i-1
            else:
                if s[i-1]==s[len(nums)]-s[i]:
                    return i-1
        return -1

灵神解法

他其实每次都在使用的是总和,然后灵神巧妙地借助了leftS,完成了这个巧夺天工的解题思路。

相关推荐
Nil2082 小时前
leetcode 198打家劫舍
算法·leetcode·职场和发展
Shaoshing2 小时前
前缀和与差分
java·数据结构·算法·前缀和·差分
mmmmath_33 小时前
LeetCode.429.N叉树的层序遍历
数据结构·leetcode
loulanyue_3 小时前
构建房产认知决策智能:Harness底座与AI自进化的技术实践——读贝壳首席算法科学家尹俊希2026云栖专场演讲
人工智能·算法
碧海银沙音频科技研究院3 小时前
基于炬芯ATS录音卡BLE控制协议
人工智能·嵌入式硬件·算法·语音识别
suhan4 小时前
【数据结构】三、栈和队列:6.链队列、双端队列、队列的应用(树的层次遍历、广度优先BFS、先来先服务FCFS)
数据结构·后端·算法
姜鱼问生4 小时前
Docker Volume 备份与恢复实战:不停机迁移数据
后端·算法·架构
suhan4 小时前
【数据结构】三、栈和队列:5.顺序队列(循环队列)(初始化,判空判满,入队,出队,实例)
数据结构·后端·算法
suhan4 小时前
【数据结构】三、栈和队列:3.链栈(链栈栈的初始化,判空,进栈,出栈,读取栈顶,链栈实例)
数据结构·后端·算法
大雄很用心4 小时前
如何理解时间复杂度与空间复杂度?| 面试刷题笔记02
算法